# Class BasicRadioButtonUI

java.lang.Object
javax.swing.plaf.ComponentUI
javax.swing.plaf.ButtonUI
javax.swing.plaf.basic.BasicButtonUI
javax.swing.plaf.basic.BasicToggleButtonUI
javax.swing.plaf.basic.BasicRadioButtonUI

Direct Known Subclasses:
  `BasicCheckBoxUI, MetalRadioButtonUI`

public class BasicRadioButtonUI extends BasicToggleButtonUI
RadioButtonUI implementation for BasicRadioButtonUI

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `protected Icon`
  `icon`
  The icon.

  ### Fields declared in class BasicButtonUI

  `defaultTextIconGap, defaultTextShiftOffset`
  Modifier and Type
  Field
  Description
  `protected int`
  `defaultTextIconGap`
  The default gap between a text and an icon.
  `protected int`
  `defaultTextShiftOffset`
  The default offset of a text.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `BasicRadioButtonUI()`
  Constructs a `BasicRadioButtonUI`.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static ComponentUI`
  `createUI(JComponent b)`
  Returns an instance of `BasicRadioButtonUI`.
  `Icon`
  `getDefaultIcon()`
  Returns the default icon.
  `Dimension`
  `getPreferredSize(JComponent c)`
  The preferred size of the radio button
  `void`
  `paint(Graphics g, JComponent c)`
  paint the radio button
  `protected void`
  `paintFocus(Graphics g, Rectangle textRect, Dimension size)`
  Paints focused radio button.

  ### Methods declared in class BasicToggleButtonUI

  `getTextShiftOffset, paintIcon`
  Modifier and Type
  Method
  Description
  `protected int`
  `getTextShiftOffset()`
  Overridden so that the text will not be rendered as shifted for Toggle buttons and subclasses.
  `protected void`
  `paintIcon(Graphics g, AbstractButton b, Rectangle iconRect)`
  Paints an icon in the specified location.

  ### Methods declared in class BasicButtonUI

  `clearTextShiftOffset, createButtonListener, getBaseline, getBaselineResizeBehavior, getDefaultTextIconGap, getPropertyPrefix, installDefaults, installKeyboardActions, installListeners, paintButtonPressed, paintFocus, paintIcon, paintText, paintText, setTextShiftOffset, uninstallDefaults, uninstallKeyboardActions, uninstallListeners`
  Modifier and Type
  Method
  Description
  `protected void`
  `clearTextShiftOffset()`
  Clears the offset of the text.
  `protected BasicButtonListener`
  `createButtonListener(AbstractButton b)`
  Returns a new instance of `BasicButtonListener`.
  `int`
  `getBaseline(JComponent c, int width, int height)`
  Returns the baseline.
  `Component.BaselineResizeBehavior`
  `getBaselineResizeBehavior(JComponent c)`
  Returns an enum indicating how the baseline of the component changes as the size changes.
  `int`
  `getDefaultTextIconGap(AbstractButton b)`
  Returns the default gap between a text and an icon.
  `protected String`
  `getPropertyPrefix()`
  Returns the property prefix.
  `protected void`
  `installDefaults(AbstractButton b)`
  Installs default properties.
  `protected void`
  `installKeyboardActions(AbstractButton b)`
  Registers keyboard actions.
  `protected void`
  `installListeners(AbstractButton b)`
  Registers listeners.
  `protected void`
  `paintButtonPressed(Graphics g, AbstractButton b)`
  Paints a pressed button.
  `protected void`
  `paintFocus(Graphics g, AbstractButton b, Rectangle viewRect, Rectangle textRect, Rectangle iconRect)`
  Paints a focused button.
  `protected void`
  `paintIcon(Graphics g, JComponent c, Rectangle iconRect)`
  Paints an icon of the current button.
  `protected void`
  `paintText(Graphics g, AbstractButton b, Rectangle textRect, String text)`
  Method which renders the text of the current button.
  `protected void`
  `paintText(Graphics g, JComponent c, Rectangle textRect, String text)`
  Method which renders the text of the current button.
  `protected void`
  `setTextShiftOffset()`
  Sets the offset of the text.
  `protected void`
  `uninstallDefaults(AbstractButton b)`
  Uninstalls default properties.
  `protected void`
  `uninstallKeyboardActions(AbstractButton b)`
  Unregisters keyboard actions.
  `protected void`
  `uninstallListeners(AbstractButton b)`
  Unregisters listeners.

  ### Methods declared in class ComponentUI

  `contains, getAccessibleChild, getAccessibleChildrenCount, getMaximumSize, getMinimumSize, installUI, uninstallUI, update`
  Modifier and Type
  Method
  Description
  `boolean`
  `contains(JComponent c, int x, int y)`
  Returns `true` if the specified x,y location is contained within the look and feel's defined shape of the specified component.
  `Accessible`
  `getAccessibleChild(JComponent c, int i)`
  Returns the `i`th `Accessible` child of the object.
  `int`
  `getAccessibleChildrenCount(JComponent c)`
  Returns the number of accessible children in the object.
  `Dimension`
  `getMaximumSize(JComponent c)`
  Returns the specified component's maximum size appropriate for the look and feel.
  `Dimension`
  `getMinimumSize(JComponent c)`
  Returns the specified component's minimum size appropriate for the look and feel.
  `void`
  `installUI(JComponent c)`
  Configures the specified component appropriately for the look and feel.
  `void`
  `uninstallUI(JComponent c)`
  Reverses configuration which was done on the specified component during `installUI`.
  `void`
  `update(Graphics g, JComponent c)`
  Notifies this UI delegate that it is time to paint the specified component.

  ### Methods declared in class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`
  Modifier and Type
  Method
  Description
  `protected Object`
  `clone()`
  Creates and returns a copy of this object.
  `boolean`
  `equals(Object obj)`
  Indicates whether some other object is "equal to" this one.
  `protected void`
  `finalize()`
  Deprecated, for removal: This API element is subject to removal in a future version.
  Finalization is deprecated and subject to removal in a future release.
  `final Class<?>`
  `getClass()`
  Returns the runtime class of this `Object`.
  `int`
  `hashCode()`
  Returns a hash code value for this object.
  `final void`
  `notify()`
  Wakes up a single thread that is waiting on this object's monitor.
  `final void`
  `notifyAll()`
  Wakes up all threads that are waiting on this object's monitor.
  `String`
  `toString()`
  Returns a string representation of the object.
  `final void`
  `wait()`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
  `final void`
  `wait(long timeoutMillis)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
  `final void`
  `wait(long timeoutMillis, int nanos)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

- ## Field Details

  - ### icon

    protected Icon icon
    The icon.

- ## Constructor Details

  - ### BasicRadioButtonUI

    public BasicRadioButtonUI()
    Constructs a `BasicRadioButtonUI`.

- ## Method Details

  - ### createUI

    public static ComponentUI createUI(JComponent b)
    Returns an instance of `BasicRadioButtonUI`.
    Parameters:
      `b` - a component
    Returns:
      an instance of `BasicRadioButtonUI`

  - ### getDefaultIcon

    public Icon getDefaultIcon()
    Returns the default icon.
    Returns:
      the default icon

  - ### paint

    public void paint(Graphics g, JComponent c)
    paint the radio button
    Overrides:
      `paint` in class `ComponentUI`
    Parameters:
      `g` - the `Graphics` context in which to paint
      `c` - the component being painted; this argument is often ignored, but might be used if the UI object is stateless and shared by multiple components
    See Also:
      - `ComponentUI.update(Graphics, JComponent)`

  - ### paintFocus

    protected void paintFocus(Graphics g, Rectangle textRect, Dimension size)
    Paints focused radio button.
    Parameters:
      `g` - an instance of `Graphics`
      `textRect` - bounds
      `size` - the size of radio button

  - ### getPreferredSize

    public Dimension getPreferredSize(JComponent c)
    The preferred size of the radio button
    Overrides:
      `getPreferredSize` in class `ComponentUI`
    Parameters:
      `c` - the component whose preferred size is being queried; this argument is often ignored, but might be used if the UI object is stateless and shared by multiple components
    Returns:
      a `Dimension` object containing given component's preferred size appropriate for the look and feel
    See Also:
      - `JComponent.getPreferredSize()`
      - `LayoutManager.preferredLayoutSize(Container)`